#include <iostream>
#include "rect.h"
#include <assert.h>
#include "bitmap.h"

using namespace std;
/*Decleration of all functions used in display of first three pages of game */
void Load_BitMap(BitMap &,const Position &);			//func to assert and set position and draw bitmap
void Page1();											//display contents of page 1 		
int mouseClick(const Position &);						//respond to mouse click on page 1
void End1();											//close window when quit in selected
void Page2();											//display content of page 2
int Page2_Click(const Position &);
void Double_Player_Page1();
int DP_Page1_Click(const Position &);
void Single_Player_Page1();
int SP_Page1_Click(const Position &);

SimpleWindow w("My first window",18.0,13.0);
SimpleWindow w1("POKET TANK",18.0,13,0);
BitMap Image1_Page1(w),Image2_Page1(w),Image3_Page1(w),Image1_Page2(w),Image2_Page2(w),Image1_DP_Page1(w),Image2_DP_Page1(w),Image1_SP_Page1(w);

char ar[30],posno=-1;
int No_of_Enter=0;
float X=w.GetWidth()/2+1.0,Y=3.0,xcor=0.0;
enum caps {on,off};
caps capslock=off;
const char ch[40][2]={"1","2","3","4","5","6","7","8","9","0",
		"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z",
		"S","B","C","E"};	
char GetChar(int);
void Draw_Keyboard();
int GetName(const Position &);


void Load_BitMap(BitMap &Image,const Position &Pos)
{	assert(Image.GetStatus() == BitMapOkay);
	Image.SetPosition(Pos);	
	Image.Draw();
}

void Page1()
{	Image1_Page1.Load("1.xpm");
	Load_BitMap(Image1_Page1,Position(0.0,0.0));	
	Image2_Page1.Load("3.xpm");
	Load_BitMap(Image2_Page1,Position(w.GetWidth()/2-3.0,11.0));
	Image3_Page1.Load("2.xpm");
	Load_BitMap(Image3_Page1,Position(w.GetWidth()/2+1.0,11.0));
	w.SetMouseClickCallback(mouseClick);	
}

int mouseClick(const Position &Pos)
{	if(Image2_Page1.IsInside(Pos))
	{	Page2();
	}
	if(Image3_Page1.IsInside(Pos))
	{	End1();
	}
	return 1;
}

void End1()
{	w.Close();
}

void Page2()
{	w.Erase(Position(0.0,0.0),w.GetWidth(),w.GetHeight());
	Image2_Page1.Erase();
	Image1_Page1.Erase();
	Image3_Page1.Erase();
	w.RenderRectangle(Position(0.0,0.0),Position(w.GetWidth(),w.GetHeight()),Black,false);
	Image1_Page2.Load("4.xpm"); 	
	Load_BitMap(Image1_Page2,Position(w.GetWidth()/2-2.5,w.GetHeight()/2-2.5));
	Image2_Page2.Load("5.xpm");
	Load_BitMap(Image2_Page2,Position(w.GetWidth()/2-2.5,w.GetHeight()/2+2.5));
	w.SetMouseClickCallback(Page2_Click);	
}
int Page2_Click(const Position &Pos)
{	if(Image1_Page2.IsInside(Pos))
	{	Single_Player_Page1();
	}
	if(Image2_Page2.IsInside(Pos))
	{	Double_Player_Page1();
	}
	return 1;
}

void Double_Player_Page1()
{	w.Erase(Position(0.0,0.0),w.GetWidth(),w.GetHeight());
	Image1_Page2.Erase();	
	Image2_Page2.Erase();
	Image1_DP_Page1.Load("6.xpm");
	w.RenderRectangle(Position(0.0,0.0),Position(w.GetWidth(),w.GetHeight()),Black,false);
	Load_BitMap(Image1_DP_Page1,Position(w.GetWidth()/2-0.5,3.0));
	Image2_DP_Page1.Load("7.xpm");
	Load_BitMap(Image2_DP_Page1,Position(w.GetWidth()/2-0.5,5.0));
	Draw_Keyboard();
	w.SetMouseClickCallback(DP_Page1_Click);
}

int DP_Page1_Click(const Position &Pos)
{	GetName(Pos);
	if(No_of_Enter==2)
	{	w.Close();
		w1.Open();
	}
	return 1;
}
void Single_Player_Page1()
{	w.Erase(Position(0.0,0.0),w.GetWidth(),w.GetHeight());
	Image1_Page2.Erase();	
	Image2_Page2.Erase();
	w.RenderRectangle(Position(0.0,0.0),Position(w.GetWidth(),w.GetHeight()),Black,false);	
	Image1_SP_Page1.Load("6.xpm");
	Load_BitMap(Image1_SP_Page1,Position(w.GetWidth()/2-0.5,3.0));
	Draw_Keyboard();
	w.SetMouseClickCallback(SP_Page1_Click);
}
int SP_Page1_Click(const Position &Pos)
{	GetName(Pos);
	if(No_of_Enter)
	{	w.Close();	
		w1.Open();
	}
	return 1;
}

int ApiMain()
{
  	w.Open();cout<<"a";
	Page1();
	
	return 0;
}
int ApiEnd()
{w.Close();
return 0;
}

void Draw_Keyboard()
{	int k=0;
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	float x=0.0,y=w.GetHeight()*3/4;
	for(float j=y;j<=w.GetHeight()-h;j+=h)
	{	//if(j==y+h) ch='A';
		for(float i=x;i<=w.GetWidth()-b;i+=b)
		{	w.RenderRectangle(Position(i,j),Position(i+b,j+h),Green,true);
			//if(!(j==y+3*h && i<=x+6*b))
			w.RenderText(Position(i+b/2,j+h/2),ch[k],Black,Green);
			++k;
		}
	}  
}
int GetName(const Position &pos)
{	float x=pos.GetXDistance(),y=pos.GetYDistance(),yadd=0;
	float b=w.GetWidth()/10;
	float h=w.GetHeight()/16;
	if(y>=w.GetHeight()*3/4)
	{	int coln=int(x/b)+1,rown=int((y-(w.GetHeight()*3/4))/h);
		int chart=10*rown+coln;
		
		if(chart==40)
		{	++No_of_Enter;
		}		
		if(chart==38)
		{	if(posno>0) 
			{	ar[posno]='\0';
				--posno;
		 		w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black,Black);
				xcor-=0.5;
			}
		}
		else if(chart==37)
		{	++posno;xcor+=0.5;
			ar[posno]=32;
			w.RenderText(Position(X+xcor,Y),Position(X+xcor+0.5,Y+0.5)," ",Black,Black);
		}
		else if(chart==39)
		{	if(capslock==off)capslock=on;
			else			 capslock=off;
		}
		else 
		{	if(posno<30)
			{	if(capslock==on) 
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart)-32;
				}
				else
				{	++posno;xcor+=0.5;
					ar[posno]=GetChar(chart);
				}
				if(No_of_Enter)yadd=2.0;
				if(chart<39)
					w.RenderText(Position(X+xcor,Y+yadd),Position(X+xcor+0.5,Y+yadd+0.5),ch[chart-1],White,Black);
			}
		}
	}
	return 1;
}

char GetChar(int chart)
{	char ch1[41]="1234567890abcdefghijklmnopqrstuvwxyzSBCE";
	char cc=ch1[chart-1];
	return cc;
}
